Browse Source

bash

master
Robin Thoni 8 years ago
parent
commit
e0bf26ddb2
5 changed files with 286 additions and 485 deletions
  1. 5
    1
      bash/bash_aliases
  2. 224
    0
      bash/bash_preexec
  3. 55
    0
      bash/bash_preexec_hooks
  4. 2
    0
      bash/bashrc
  5. 0
    484
      git-prompt.sh

bash_aliases → bash/bash_aliases View File

@@ -10,7 +10,7 @@ alias lock="i3lock"
10 10
 alias traceroute="traceroute -n"
11 11
 alias reload="source ~/.bashrc"
12 12
 alias wakeserv4="wakeonlan -i 192.168.1.255 00:1f:d0:db:d9:c8"
13
-alias shutserv4="ssh serv4 shutdown -h 0"
13
+alias shutserv4="ssh serv4 shutdown -hP 0"
14 14
 alias shut="sudo shutdown -h 0"
15 15
 alias shutms="shutserv4 && shut"
16 16
 alias service="sudo service"
@@ -55,6 +55,8 @@ alias arpw="arp-scan -I wlan0"
55 55
 alias ping="ping -n"
56 56
 alias vpnint="service openvpn restart g75-internet"
57 57
 alias vpnintstop="service openvpn stop g75-internet"
58
+alias vpnepi="service openvpn restart rob-1-epimafia-internet"
59
+alias vpnepistop="service openvpn stop rob-1-epimafia-internet"
58 60
 alias vpnbe="service openvpn restart g75-betaclean"
59 61
 alias vpnbestop="service openvpn stop g75-betaclean"
60 62
 alias youtube-mp3="youtube-dl --extract-audio --audio-format mp3"
@@ -68,3 +70,5 @@ alias p="ping 8.8.8.8"
68 70
 alias pe="ping epigate.epimafia.fr"
69 71
 alias telnet='telnet -e ^['
70 72
 alias gparted="sudo gparted"
73
+alias hopper="LD_LIBRARY_PATH=/opt/hopper-v3/ /opt/hopper-v3/Hopper"
74
+alias reboot-win="grub-reboot 2 && reboot"

+ 224
- 0
bash/bash_preexec View File

@@ -0,0 +1,224 @@
1
+#!/bin/bash
2
+#
3
+# bash-preexec.sh -- Bash support for ZSH-like 'preexec' and 'precmd' functions.
4
+# https://github.com/rcaloras/bash-preexec
5
+#
6
+#
7
+# 'preexec' functions are executed before each interactive command is
8
+# executed, with the interactive command as its argument.  The 'precmd'
9
+# function is executed before each prompt is displayed.
10
+#
11
+# Author: Ryan Caloras (ryan@bashhub.com)
12
+# Forked from Original Author: Glyph Lefkowitz
13
+#
14
+# V0.2.1
15
+#
16
+
17
+# General Usage:
18
+#
19
+#  1. Source this file at the end of your bash profile so as not to interfere
20
+#     with anything else that's using PROMPT_COMMAND.
21
+#
22
+#  2. Add any precmd or preexec functions by appending them to their arrays:
23
+#       e.g.
24
+#       precmd_functions+=(my_precmd_function)
25
+#       precmd_functions+=(some_other_precmd_function)
26
+#
27
+#       preexec_functions+=(my_preexec_function)
28
+#
29
+#  3. If you have anything that's using the Debug Trap, change it to use
30
+#     preexec. (Optional) change anything using PROMPT_COMMAND to now use
31
+#     precmd instead.
32
+#
33
+#  Note: This module requires two bash features which you must not otherwise be
34
+#  using: the "DEBUG" trap, and the "PROMPT_COMMAND" variable. prexec_and_precmd_install
35
+#  will override these and if you override one or the other this will most likely break.
36
+
37
+# Avoid duplicate inclusion
38
+if [[ "$__bp_imported" == "defined" ]]; then
39
+    return 0
40
+fi
41
+__bp_imported="defined"
42
+
43
+
44
+# Remove ignorespace and or replace ignoreboth from HISTCONTROL
45
+# so we can accurately invoke preexec with a command from our
46
+# history even if it starts with a space.
47
+__bp_adjust_histcontrol() {
48
+    local histcontrol
49
+    histcontrol="${HISTCONTROL//ignorespace}"
50
+    # Replace ignoreboth with ignoredups
51
+    if [[ "$histcontrol" == *"ignoreboth"* ]]; then
52
+        histcontrol="ignoredups:${histcontrol//ignoreboth}"
53
+    fi;
54
+    export HISTCONTROL="$histcontrol"
55
+}
56
+
57
+# This variable describes whether we are currently in "interactive mode";
58
+# i.e. whether this shell has just executed a prompt and is waiting for user
59
+# input.  It documents whether the current command invoked by the trace hook is
60
+# run interactively by the user; it's set immediately after the prompt hook,
61
+# and unset as soon as the trace hook is run.
62
+__bp_preexec_interactive_mode=""
63
+
64
+__bp_trim_whitespace() {
65
+    local var=$@
66
+    var="${var#"${var%%[![:space:]]*}"}"   # remove leading whitespace characters
67
+    var="${var%"${var##*[![:space:]]}"}"   # remove trailing whitespace characters
68
+    echo -n "$var"
69
+}
70
+
71
+# This function is installed as part of the PROMPT_COMMAND;
72
+# It sets a variable to indicate that the prompt was just displayed,
73
+# to allow the DEBUG trap to know that the next command is likely interactive.
74
+__bp_interactive_mode() {
75
+    __bp_preexec_interactive_mode="on";
76
+}
77
+
78
+
79
+# This function is installed as part of the PROMPT_COMMAND.
80
+# It will invoke any functions defined in the precmd_functions array.
81
+__bp_precmd_invoke_cmd() {
82
+
83
+    # Should be available to each precmd function, should it want it.
84
+    local ret_value="$?"
85
+
86
+    # For every function defined in our function array. Invoke it.
87
+    local precmd_function
88
+    for precmd_function in ${precmd_functions[@]}; do
89
+
90
+        # Only execute this function if it actually exists.
91
+        if [[ -n $(type -t $precmd_function) ]]; then
92
+            __bp_set_ret_value $ret_value
93
+            $precmd_function
94
+        fi
95
+    done
96
+}
97
+
98
+# Sets a return value in $?. We may want to get access to the $? variable in our
99
+# precmd functions. This is available for instance in zsh. We can simulate it in bash
100
+# by setting the value here.
101
+__bp_set_ret_value() {
102
+    return $1
103
+}
104
+
105
+__bp_in_prompt_command() {
106
+
107
+    local prompt_command_array
108
+    IFS=';' read -ra prompt_command_array <<< "$PROMPT_COMMAND"
109
+
110
+    local trimmed_arg
111
+    trimmed_arg=$(__bp_trim_whitespace "$1")
112
+
113
+    local prompt_command_function
114
+    for command in "${prompt_command_array[@]}"; do
115
+        local trimmed_command
116
+        trimmed_command=$(__bp_trim_whitespace "$command")
117
+        # Only execute each function if it actually exists.
118
+        if [[ "$trimmed_command" == "$trimmed_arg" ]]; then
119
+            return 0
120
+        fi
121
+    done
122
+
123
+    return 1
124
+}
125
+
126
+# This function is installed as the DEBUG trap.  It is invoked before each
127
+# interactive prompt display.  Its purpose is to inspect the current
128
+# environment to attempt to detect if the current command is being invoked
129
+# interactively, and invoke 'preexec' if so.
130
+__bp_preexec_invoke_exec() {
131
+
132
+    if [[ -n "$COMP_LINE" ]]
133
+    then
134
+        # We're in the middle of a completer.  This obviously can't be
135
+        # an interactively issued command.
136
+        return
137
+    fi
138
+    if [[ -z "$__bp_preexec_interactive_mode" ]]
139
+    then
140
+        # We're doing something related to displaying the prompt.  Let the
141
+        # prompt set the title instead of me.
142
+        return
143
+    else
144
+        # If we're in a subshell, then the prompt won't be re-displayed to put
145
+        # us back into interactive mode, so let's not set the variable back.
146
+        # In other words, if you have a subshell like
147
+        #   (sleep 1; sleep 2)
148
+        # You want to see the 'sleep 2' as a set_command_title as well.
149
+        if [[ 0 -eq "$BASH_SUBSHELL" ]]
150
+        then
151
+            __bp_preexec_interactive_mode=""
152
+        fi
153
+    fi
154
+
155
+    if  __bp_in_prompt_command "$BASH_COMMAND"; then
156
+        # If we're executing something inside our prompt_command then we don't
157
+        # want to call preexec. Bash prior to 3.1 can't detect this at all :/
158
+
159
+        __bp_preexec_interactive_mode=""
160
+        return
161
+    fi
162
+
163
+    local this_command="$(HISTTIMEFORMAT= history 1 | sed -e "s/^[ ]*[0-9]*[ ]*//g")";
164
+
165
+    # Sanity check to make sure we have something to invoke our function with.
166
+    if [[ -z "$this_command" ]]; then
167
+        return
168
+    fi
169
+
170
+    # If none of the previous checks have returned out of this function, then
171
+    # the command is in fact interactive and we should invoke the user's
172
+    # preexec functions.
173
+
174
+    # For every function defined in our function array. Invoke it.
175
+    local preexec_function
176
+    for preexec_function in "${preexec_functions[@]}"; do
177
+
178
+        # Only execute each function if it actually exists.
179
+        if [[ -n $(type -t $preexec_function) ]]; then
180
+            $preexec_function "$this_command"
181
+        fi
182
+    done
183
+}
184
+
185
+# Execute this to set up preexec and precmd execution.
186
+__bp_preexec_and_precmd_install() {
187
+
188
+    # Make sure this is bash that's running this and return otherwise.
189
+    if [[ -z "$BASH_VERSION" ]]; then
190
+        return 1;
191
+    fi
192
+
193
+    # Exit if we already have this installed.
194
+    if [[ "$PROMPT_COMMAND" == *"__bp_precmd_invoke_cmd"* ]]; then
195
+        return 1;
196
+    fi
197
+
198
+    # Adjust our HISTCONTROL Variable if needed.
199
+    __bp_adjust_histcontrol
200
+
201
+    # Take our existing prompt command and append a semicolon to it
202
+    # if it doesn't already have one.
203
+    local existing_prompt_command
204
+
205
+    if [[ -n "$PROMPT_COMMAND" ]]; then
206
+        existing_prompt_command=$(echo "$PROMPT_COMMAND" | sed '/; *$/!s/$/;/')
207
+    else
208
+        existing_prompt_command=""
209
+    fi
210
+
211
+    # Finally install our traps.
212
+    PROMPT_COMMAND="__bp_precmd_invoke_cmd; ${existing_prompt_command} __bp_interactive_mode;"
213
+    trap '__bp_preexec_invoke_exec' DEBUG;
214
+
215
+    # Add two functions to our arrays for convenience
216
+    # of definition.
217
+    precmd_functions+=(precmd)
218
+    preexec_functions+=(preexec)
219
+}
220
+
221
+# Run our install so long as we're not delaying it.
222
+if [[ -z "$__bp_delay_install" ]]; then
223
+    __bp_preexec_and_precmd_install
224
+fi;

+ 55
- 0
bash/bash_preexec_hooks View File

@@ -0,0 +1,55 @@
1
+#! /usr/bin/env bash
2
+
3
+export __BASH_HOOKS_TIMEOUT__=60
4
+
5
+export __BASH_HOOKS_COMMAND__=
6
+export __BASH_HOOKS_TIME__=
7
+
8
+timestamp()
9
+{
10
+  date "+%s"
11
+}
12
+
13
+preexec()
14
+{
15
+  export __BASH_HOOKS_COMMAND__="$1"
16
+  export __BASH_HOOKS_TIME__=$(timestamp)
17
+
18
+}
19
+
20
+precmd()
21
+{
22
+  if [ -n "$__BASH_HOOKS_COMMAND__" ]
23
+  then
24
+    ts=$(timestamp)
25
+    diff=$((ts - $__BASH_HOOKS_TIME__))
26
+    __bash_hooks_command_finished "$__BASH_HOOKS_COMMAND__" $diff
27
+    export __BASH_HOOKS_COMMAND__=
28
+    export __BASH_HOOKS_TIME__=
29
+  fi
30
+}
31
+
32
+displaytime()
33
+{
34
+  local T=$1
35
+  local D=$((T/60/60/24))
36
+  local H=$((T/60/60%24))
37
+  local M=$((T/60%60))
38
+  local S=$((T%60))
39
+  [[ $D > 0 ]] && printf '%d days ' $D
40
+  [[ $H > 0 ]] && printf '%d hours ' $H
41
+  [[ $M > 0 ]] && printf '%d minutes ' $M
42
+  [[ $D > 0 || $H > 0 || $M > 0 ]] && printf 'and '
43
+  printf '%d seconds\n' $S
44
+}
45
+
46
+__bash_hooks_command_finished()
47
+{
48
+  if [ "$2" -ge "$__BASH_HOOKS_TIMEOUT__" ]
49
+  then
50
+    human=$(displaytime "$2")
51
+    text="Command \"$1\" finished in $human ($2 seconds)"
52
+    echo "$text"
53
+    (nma $(hostname -f) "$1" "$text" >/dev/null 2>/dev/null &)
54
+  fi
55
+}

bashrc → bash/bashrc View File

@@ -202,3 +202,5 @@ complete -F _proj_completion proj
202 202
 export NNTPSERVER=news.epita.fr
203 203
 
204 204
 . ~/.bash_aliases
205
+. ~/.bash_preexec
206
+. ~/.bash_preexec_hooks

+ 0
- 484
git-prompt.sh View File

@@ -1,484 +0,0 @@
1
-# bash/zsh git prompt support
2
-#
3
-# Copyright (C) 2006,2007 Shawn O. Pearce <spearce@spearce.org>
4
-# Distributed under the GNU General Public License, version 2.0.
5
-#
6
-# This script allows you to see repository status in your prompt.
7
-#
8
-# To enable:
9
-#
10
-#    1) Copy this file to somewhere (e.g. ~/.git-prompt.sh).
11
-#    2) Add the following line to your .bashrc/.zshrc:
12
-#        source ~/.git-prompt.sh
13
-#    3a) Change your PS1 to call __git_ps1 as
14
-#        command-substitution:
15
-#        Bash: PS1='[\u@\h \W$(__git_ps1 " (%s)")]\$ '
16
-#        ZSH:  setopt PROMPT_SUBST ; PS1='[%n@%m %c$(__git_ps1 " (%s)")]\$ '
17
-#        the optional argument will be used as format string.
18
-#    3b) Alternatively, for a slightly faster prompt, __git_ps1 can
19
-#        be used for PROMPT_COMMAND in Bash or for precmd() in Zsh
20
-#        with two parameters, <pre> and <post>, which are strings
21
-#        you would put in $PS1 before and after the status string
22
-#        generated by the git-prompt machinery.  e.g.
23
-#        Bash: PROMPT_COMMAND='__git_ps1 "\u@\h:\w" "\\\$ "'
24
-#          will show username, at-sign, host, colon, cwd, then
25
-#          various status string, followed by dollar and SP, as
26
-#          your prompt.
27
-#        ZSH:  precmd () { __git_ps1 "%n" ":%~$ " "|%s" }
28
-#          will show username, pipe, then various status string,
29
-#          followed by colon, cwd, dollar and SP, as your prompt.
30
-#        Optionally, you can supply a third argument with a printf
31
-#        format string to finetune the output of the branch status
32
-#
33
-# The repository status will be displayed only if you are currently in a
34
-# git repository. The %s token is the placeholder for the shown status.
35
-#
36
-# The prompt status always includes the current branch name.
37
-#
38
-# In addition, if you set GIT_PS1_SHOWDIRTYSTATE to a nonempty value,
39
-# unstaged (*) and staged (+) changes will be shown next to the branch
40
-# name.  You can configure this per-repository with the
41
-# bash.showDirtyState variable, which defaults to true once
42
-# GIT_PS1_SHOWDIRTYSTATE is enabled.
43
-#
44
-# You can also see if currently something is stashed, by setting
45
-# GIT_PS1_SHOWSTASHSTATE to a nonempty value. If something is stashed,
46
-# then a '$' will be shown next to the branch name.
47
-#
48
-# If you would like to see if there're untracked files, then you can set
49
-# GIT_PS1_SHOWUNTRACKEDFILES to a nonempty value. If there're untracked
50
-# files, then a '%' will be shown next to the branch name.  You can
51
-# configure this per-repository with the bash.showUntrackedFiles
52
-# variable, which defaults to true once GIT_PS1_SHOWUNTRACKEDFILES is
53
-# enabled.
54
-#
55
-# If you would like to see the difference between HEAD and its upstream,
56
-# set GIT_PS1_SHOWUPSTREAM="auto".  A "<" indicates you are behind, ">"
57
-# indicates you are ahead, "<>" indicates you have diverged and "="
58
-# indicates that there is no difference. You can further control
59
-# behaviour by setting GIT_PS1_SHOWUPSTREAM to a space-separated list
60
-# of values:
61
-#
62
-#     verbose       show number of commits ahead/behind (+/-) upstream
63
-#     name          if verbose, then also show the upstream abbrev name
64
-#     legacy        don't use the '--count' option available in recent
65
-#                   versions of git-rev-list
66
-#     git           always compare HEAD to @{upstream}
67
-#     svn           always compare HEAD to your SVN upstream
68
-#
69
-# By default, __git_ps1 will compare HEAD to your SVN upstream if it can
70
-# find one, or @{upstream} otherwise.  Once you have set
71
-# GIT_PS1_SHOWUPSTREAM, you can override it on a per-repository basis by
72
-# setting the bash.showUpstream config variable.
73
-#
74
-# If you would like to see more information about the identity of
75
-# commits checked out as a detached HEAD, set GIT_PS1_DESCRIBE_STYLE
76
-# to one of these values:
77
-#
78
-#     contains      relative to newer annotated tag (v1.6.3.2~35)
79
-#     branch        relative to newer tag or branch (master~4)
80
-#     describe      relative to older annotated tag (v1.6.3.1-13-gdd42c2f)
81
-#     default       exactly matching tag
82
-#
83
-# If you would like a colored hint about the current dirty state, set
84
-# GIT_PS1_SHOWCOLORHINTS to a nonempty value. The colors are based on
85
-# the colored output of "git status -sb" and are available only when
86
-# using __git_ps1 for PROMPT_COMMAND or precmd.
87
-
88
-# check whether printf supports -v
89
-__git_printf_supports_v=
90
-printf -v __git_printf_supports_v -- '%s' yes >/dev/null 2>&1
91
-
92
-# stores the divergence from upstream in $p
93
-# used by GIT_PS1_SHOWUPSTREAM
94
-__git_ps1_show_upstream ()
95
-{
96
-	local key value
97
-	local svn_remote svn_url_pattern count n
98
-	local upstream=git legacy="" verbose="" name=""
99
-
100
-	svn_remote=()
101
-	# get some config options from git-config
102
-	local output="$(git config -z --get-regexp '^(svn-remote\..*\.url|bash\.showupstream)$' 2>/dev/null | tr '\0\n' '\n ')"
103
-	while read -r key value; do
104
-		case "$key" in
105
-		bash.showupstream)
106
-			GIT_PS1_SHOWUPSTREAM="$value"
107
-			if [[ -z "${GIT_PS1_SHOWUPSTREAM}" ]]; then
108
-				p=""
109
-				return
110
-			fi
111
-			;;
112
-		svn-remote.*.url)
113
-			svn_remote[$((${#svn_remote[@]} + 1))]="$value"
114
-			svn_url_pattern="$svn_url_pattern\\|$value"
115
-			upstream=svn+git # default upstream is SVN if available, else git
116
-			;;
117
-		esac
118
-	done <<< "$output"
119
-
120
-	# parse configuration values
121
-	for option in ${GIT_PS1_SHOWUPSTREAM}; do
122
-		case "$option" in
123
-		git|svn) upstream="$option" ;;
124
-		verbose) verbose=1 ;;
125
-		legacy)  legacy=1  ;;
126
-		name)    name=1 ;;
127
-		esac
128
-	done
129
-
130
-	# Find our upstream
131
-	case "$upstream" in
132
-	git)    upstream="@{upstream}" ;;
133
-	svn*)
134
-		# get the upstream from the "git-svn-id: ..." in a commit message
135
-		# (git-svn uses essentially the same procedure internally)
136
-		local -a svn_upstream
137
-		svn_upstream=($(git log --first-parent -1 \
138
-					--grep="^git-svn-id: \(${svn_url_pattern#??}\)" 2>/dev/null))
139
-		if [[ 0 -ne ${#svn_upstream[@]} ]]; then
140
-			svn_upstream=${svn_upstream[${#svn_upstream[@]} - 2]}
141
-			svn_upstream=${svn_upstream%@*}
142
-			local n_stop="${#svn_remote[@]}"
143
-			for ((n=1; n <= n_stop; n++)); do
144
-				svn_upstream=${svn_upstream#${svn_remote[$n]}}
145
-			done
146
-
147
-			if [[ -z "$svn_upstream" ]]; then
148
-				# default branch name for checkouts with no layout:
149
-				upstream=${GIT_SVN_ID:-git-svn}
150
-			else
151
-				upstream=${svn_upstream#/}
152
-			fi
153
-		elif [[ "svn+git" = "$upstream" ]]; then
154
-			upstream="@{upstream}"
155
-		fi
156
-		;;
157
-	esac
158
-
159
-	# Find how many commits we are ahead/behind our upstream
160
-	if [[ -z "$legacy" ]]; then
161
-		count="$(git rev-list --count --left-right \
162
-				"$upstream"...HEAD 2>/dev/null)"
163
-	else
164
-		# produce equivalent output to --count for older versions of git
165
-		local commits
166
-		if commits="$(git rev-list --left-right "$upstream"...HEAD 2>/dev/null)"
167
-		then
168
-			local commit behind=0 ahead=0
169
-			for commit in $commits
170
-			do
171
-				case "$commit" in
172
-				"<"*) ((behind++)) ;;
173
-				*)    ((ahead++))  ;;
174
-				esac
175
-			done
176
-			count="$behind	$ahead"
177
-		else
178
-			count=""
179
-		fi
180
-	fi
181
-
182
-	# calculate the result
183
-	if [[ -z "$verbose" ]]; then
184
-		case "$count" in
185
-		"") # no upstream
186
-			p="" ;;
187
-		"0	0") # equal to upstream
188
-			p="=" ;;
189
-		"0	"*) # ahead of upstream
190
-			p=">" ;;
191
-		*"	0") # behind upstream
192
-			p="<" ;;
193
-		*)	    # diverged from upstream
194
-			p="<>" ;;
195
-		esac
196
-	else
197
-		case "$count" in
198
-		"") # no upstream
199
-			p="" ;;
200
-		"0	0") # equal to upstream
201
-			p=" u=" ;;
202
-		"0	"*) # ahead of upstream
203
-			p=" u+${count#0	}" ;;
204
-		*"	0") # behind upstream
205
-			p=" u-${count%	0}" ;;
206
-		*)	    # diverged from upstream
207
-			p=" u+${count#*	}-${count%	*}" ;;
208
-		esac
209
-		if [[ -n "$count" && -n "$name" ]]; then
210
-			__git_ps1_upstream_name=$(git rev-parse \
211
-				--abbrev-ref "$upstream" 2>/dev/null)
212
-			if [ $pcmode = yes ]; then
213
-				# see the comments around the
214
-				# __git_ps1_branch_name variable below
215
-				p="$p \${__git_ps1_upstream_name}"
216
-			else
217
-				p="$p ${__git_ps1_upstream_name}"
218
-				# not needed anymore; keep user's
219
-				# environment clean
220
-				unset __git_ps1_upstream_name
221
-			fi
222
-		fi
223
-	fi
224
-
225
-}
226
-
227
-# Helper function that is meant to be called from __git_ps1.  It
228
-# injects color codes into the appropriate gitstring variables used
229
-# to build a gitstring.
230
-__git_ps1_colorize_gitstring ()
231
-{
232
-	if [[ -n ${ZSH_VERSION-} ]]; then
233
-		local c_red='%F{red}'
234
-		local c_green='%F{green}'
235
-		local c_lblue='%F{blue}'
236
-		local c_clear='%f'
237
-	else
238
-		# Using \[ and \] around colors is necessary to prevent
239
-		# issues with command line editing/browsing/completion!
240
-		local c_red='\[\e[31m\]'
241
-		local c_green='\[\e[32m\]'
242
-		local c_lblue='\[\e[1;34m\]'
243
-		local c_clear='\[\e[0m\]'
244
-	fi
245
-	local bad_color=$c_red
246
-	local ok_color=$c_green
247
-	local flags_color="$c_lblue"
248
-
249
-	local branch_color=""
250
-	if [ $detached = no ]; then
251
-		branch_color="$ok_color"
252
-	else
253
-		branch_color="$bad_color"
254
-	fi
255
-	c="$branch_color$c"
256
-
257
-	z="$c_clear$z"
258
-	if [ "$w" = "*" ]; then
259
-		w="$bad_color$w"
260
-	fi
261
-	if [ -n "$i" ]; then
262
-		i="$ok_color$i"
263
-	fi
264
-	if [ -n "$s" ]; then
265
-		s="$flags_color$s"
266
-	fi
267
-	if [ -n "$u" ]; then
268
-		u="$bad_color$u"
269
-	fi
270
-	r="$c_clear$r"
271
-}
272
-
273
-# __git_ps1 accepts 0 or 1 arguments (i.e., format string)
274
-# when called from PS1 using command substitution
275
-# in this mode it prints text to add to bash PS1 prompt (includes branch name)
276
-#
277
-# __git_ps1 requires 2 or 3 arguments when called from PROMPT_COMMAND (pc)
278
-# in that case it _sets_ PS1. The arguments are parts of a PS1 string.
279
-# when two arguments are given, the first is prepended and the second appended
280
-# to the state string when assigned to PS1.
281
-# The optional third parameter will be used as printf format string to further
282
-# customize the output of the git-status string.
283
-# In this mode you can request colored hints using GIT_PS1_SHOWCOLORHINTS=true
284
-__git_ps1 ()
285
-{
286
-	local pcmode=no
287
-	local detached=no
288
-	local ps1pc_start='\u@\h:\w '
289
-	local ps1pc_end='\$ '
290
-	local printf_format=' (%s)'
291
-
292
-	case "$#" in
293
-		2|3)	pcmode=yes
294
-			ps1pc_start="$1"
295
-			ps1pc_end="$2"
296
-			printf_format="${3:-$printf_format}"
297
-		;;
298
-		0|1)	printf_format="${1:-$printf_format}"
299
-		;;
300
-		*)	return
301
-		;;
302
-	esac
303
-
304
-	local repo_info rev_parse_exit_code
305
-	repo_info="$(git rev-parse --git-dir --is-inside-git-dir \
306
-		--is-bare-repository --is-inside-work-tree \
307
-		--short HEAD 2>/dev/null)"
308
-	rev_parse_exit_code="$?"
309
-
310
-	if [ -z "$repo_info" ]; then
311
-		if [ $pcmode = yes ]; then
312
-			#In PC mode PS1 always needs to be set
313
-			PS1="$ps1pc_start$ps1pc_end"
314
-		fi
315
-		return
316
-	fi
317
-
318
-	local short_sha
319
-	if [ "$rev_parse_exit_code" = "0" ]; then
320
-		short_sha="${repo_info##*$'\n'}"
321
-		repo_info="${repo_info%$'\n'*}"
322
-	fi
323
-	local inside_worktree="${repo_info##*$'\n'}"
324
-	repo_info="${repo_info%$'\n'*}"
325
-	local bare_repo="${repo_info##*$'\n'}"
326
-	repo_info="${repo_info%$'\n'*}"
327
-	local inside_gitdir="${repo_info##*$'\n'}"
328
-	local g="${repo_info%$'\n'*}"
329
-
330
-	local r=""
331
-	local b=""
332
-	local step=""
333
-	local total=""
334
-	if [ -d "$g/rebase-merge" ]; then
335
-		read b 2>/dev/null <"$g/rebase-merge/head-name"
336
-		read step 2>/dev/null <"$g/rebase-merge/msgnum"
337
-		read total 2>/dev/null <"$g/rebase-merge/end"
338
-		if [ -f "$g/rebase-merge/interactive" ]; then
339
-			r="|REBASE-i"
340
-		else
341
-			r="|REBASE-m"
342
-		fi
343
-	else
344
-		if [ -d "$g/rebase-apply" ]; then
345
-			read step 2>/dev/null <"$g/rebase-apply/next"
346
-			read total 2>/dev/null <"$g/rebase-apply/last"
347
-			if [ -f "$g/rebase-apply/rebasing" ]; then
348
-				read b 2>/dev/null <"$g/rebase-apply/head-name"
349
-				r="|REBASE"
350
-			elif [ -f "$g/rebase-apply/applying" ]; then
351
-				r="|AM"
352
-			else
353
-				r="|AM/REBASE"
354
-			fi
355
-		elif [ -f "$g/MERGE_HEAD" ]; then
356
-			r="|MERGING"
357
-		elif [ -f "$g/CHERRY_PICK_HEAD" ]; then
358
-			r="|CHERRY-PICKING"
359
-		elif [ -f "$g/REVERT_HEAD" ]; then
360
-			r="|REVERTING"
361
-		elif [ -f "$g/BISECT_LOG" ]; then
362
-			r="|BISECTING"
363
-		fi
364
-
365
-		if [ -n "$b" ]; then
366
-			:
367
-		elif [ -h "$g/HEAD" ]; then
368
-			# symlink symbolic ref
369
-			b="$(git symbolic-ref HEAD 2>/dev/null)"
370
-		else
371
-			local head=""
372
-			if ! read head 2>/dev/null <"$g/HEAD"; then
373
-				if [ $pcmode = yes ]; then
374
-					PS1="$ps1pc_start$ps1pc_end"
375
-				fi
376
-				return
377
-			fi
378
-			# is it a symbolic ref?
379
-			b="${head#ref: }"
380
-			if [ "$head" = "$b" ]; then
381
-				detached=yes
382
-				b="$(
383
-				case "${GIT_PS1_DESCRIBE_STYLE-}" in
384
-				(contains)
385
-					git describe --contains HEAD ;;
386
-				(branch)
387
-					git describe --contains --all HEAD ;;
388
-				(describe)
389
-					git describe HEAD ;;
390
-				(* | default)
391
-					git describe --tags --exact-match HEAD ;;
392
-				esac 2>/dev/null)" ||
393
-
394
-				b="$short_sha..."
395
-				b="($b)"
396
-			fi
397
-		fi
398
-	fi
399
-
400
-	if [ -n "$step" ] && [ -n "$total" ]; then
401
-		r="$r $step/$total"
402
-	fi
403
-
404
-	local w=""
405
-	local i=""
406
-	local s=""
407
-	local u=""
408
-	local c=""
409
-	local p=""
410
-
411
-	if [ "true" = "$inside_gitdir" ]; then
412
-		if [ "true" = "$bare_repo" ]; then
413
-			c="BARE:"
414
-		else
415
-			b="GIT_DIR!"
416
-		fi
417
-	elif [ "true" = "$inside_worktree" ]; then
418
-		if [ -n "${GIT_PS1_SHOWDIRTYSTATE-}" ] &&
419
-		   [ "$(git config --bool bash.showDirtyState)" != "false" ]
420
-		then
421
-			git diff --no-ext-diff --quiet --exit-code || w="*"
422
-			if [ -n "$short_sha" ]; then
423
-				git diff-index --cached --quiet HEAD -- || i="+"
424
-			else
425
-				i="#"
426
-			fi
427
-		fi
428
-		if [ -n "${GIT_PS1_SHOWSTASHSTATE-}" ] &&
429
-		   [ -r "$g/refs/stash" ]; then
430
-			s="$"
431
-		fi
432
-
433
-		if [ -n "${GIT_PS1_SHOWUNTRACKEDFILES-}" ] &&
434
-		   [ "$(git config --bool bash.showUntrackedFiles)" != "false" ] &&
435
-		   git ls-files --others --exclude-standard --error-unmatch -- '*' >/dev/null 2>/dev/null
436
-		then
437
-			u="%${ZSH_VERSION+%}"
438
-		fi
439
-
440
-		if [ -n "${GIT_PS1_SHOWUPSTREAM-}" ]; then
441
-			__git_ps1_show_upstream
442
-		fi
443
-	fi
444
-
445
-	local z="${GIT_PS1_STATESEPARATOR-" "}"
446
-
447
-	# NO color option unless in PROMPT_COMMAND mode
448
-	if [ $pcmode = yes ] && [ -n "${GIT_PS1_SHOWCOLORHINTS-}" ]; then
449
-		__git_ps1_colorize_gitstring
450
-	fi
451
-
452
-	b=${b##refs/heads/}
453
-	if [ $pcmode = yes ]; then
454
-		# In pcmode (and only pcmode) the contents of
455
-		# $gitstring are subject to expansion by the shell.
456
-		# Avoid putting the raw ref name in the prompt to
457
-		# protect the user from arbitrary code execution via
458
-		# specially crafted ref names (e.g., a ref named
459
-		# '$(IFS=_;cmd=sudo_rm_-rf_/;$cmd)' would execute
460
-		# 'sudo rm -rf /' when the prompt is drawn).  Instead,
461
-		# put the ref name in a new global variable (in the
462
-		# __git_ps1_* namespace to avoid colliding with the
463
-		# user's environment) and reference that variable from
464
-		# PS1.
465
-		__git_ps1_branch_name=$b
466
-		# note that the $ is escaped -- the variable will be
467
-		# expanded later (when it's time to draw the prompt)
468
-		b="\${__git_ps1_branch_name}"
469
-	fi
470
-
471
-	local f="$w$i$s$u"
472
-	local gitstring="$c$b${f:+$z$f}$r$p"
473
-
474
-	if [ $pcmode = yes ]; then
475
-		if [ "${__git_printf_supports_v-}" != yes ]; then
476
-			gitstring=$(printf -- "$printf_format" "$gitstring")
477
-		else
478
-			printf -v gitstring -- "$printf_format" "$gitstring"
479
-		fi
480
-		PS1="$ps1pc_start$gitstring$ps1pc_end"
481
-	else
482
-		printf -- "$printf_format" "$gitstring"
483
-	fi
484
-}

Loading…
Cancel
Save